import React, { ErrorInfo } from 'react';
import PropTypes from 'prop-types';
import { NextComponentType, IContext, AppContextType, AppInitialProps, AppPropsType } from 'next-server/dist/lib/utils';
export { NextComponentType, IContext, AppInitialProps };
declare type Router = import('next-server/dist/lib/router/router').default;
export declare type AppContext = AppContextType<Router>;
export declare type AppProps = AppPropsType<Router>;
export default class App extends React.Component<AppProps> {
    static childContextTypes: {
        router: PropTypes.Requireable<object>;
    };
    static getInitialProps({ Component, ctx }: AppContext): Promise<AppInitialProps>;
    getChildContext(): {
        router: import("../client/router").PublicRouterInstance;
    };
    componentDidCatch(error: Error, _errorInfo: ErrorInfo): void;
    render(): JSX.Element;
}
export declare class Container extends React.Component {
    componentDidMount(): void;
    componentDidUpdate(): void;
    private scrollToHash;
    render(): React.ReactNode;
}
export declare function createUrl(router: Router): {
    readonly query: string;
    readonly pathname: string;
    readonly asPath: string;
    back: () => void;
    push: (url: string, as?: string | undefined) => Promise<boolean>;
    pushTo: (href: string, as?: string | undefined) => Promise<boolean>;
    replace: (url: string, as?: string | undefined) => Promise<boolean>;
    replaceTo: (href: string, as?: string | undefined) => Promise<boolean>;
};
